;Programme par Denis Duplan (denis_duplan@yahoo.fr)
;Cette oeuvre est mise  disposition selon les termes de la Licence Creative Commons Attribution (http://creativecommons.org/licenses/by-nc-sa/4.0/fr/) - Pas dUtilisation Commerciale - Partage dans les Mmes Conditions 4.0 France

;Coded by Yragael
;update in 2003 : updated noisetracker routine with some pc (?) routine
	section prg,code_c
	include "sources:comotion/registres.s"

;*************** INDEX FONCTIONS ***************

openlibrary=-552
forbid=-132
permit=-138
allocmem=-198
freemem=-210

;*************** PARAMETRES FICHIERS ***************

logosizex=320
logosizey=41
logosize=logosizex*logosizey/8

fontsizex=320
fontsizey=48
fontsize=fontsizex*fontsizey/8

;*************** PARAMETRES DU SCREEN GLOBAL ***************

nbplane=2
sizey=46+190+20+2

startx=129				;depart horizontal du trac
starty=42				;depart vertical du trac

displayy=sizey				;hauteur de l'image a visualiser  ...
					;... partir de starty

startdisplayx=129			;debut horizontal visible de l'image

stopy=displayy+starty-256		;fin verticale visible de l'image

;*************** PARAMETRES DES ECRANS ***************

sizex0=320
sizey0=2*logosizey+5*2
screen0size=sizex0*sizey0/8
displayx0=320
tracex0=320
stopx0=displayx0+startdisplayx-256
ddf_strt0=(startx-17)/2 
ddf_stop0=ddf_strt0+(tracex0/2-8)
modulo_pair0=(sizex0-tracex0)/8+(nbplane-1)*sizex0/8
modulo_impair0=(sizex0-tracex0)/8+(nbplane-1)*sizex0/8

sizex1=640*3
sizey1=190
screen1size=sizex1*sizey1/8
displayx1=640
tracex1=640+16				;pas +8, doit etre multiple de 16 !
startx1=startx-8			;en medium, 1 hardx = 2 pixels
stopx1=displayx1/2+startdisplayx-256
ddf_strt1=(startx1-9)/2
ddf_stop1=ddf_strt1+(tracex1/4-8)
modulo_pair1=(sizex1-tracex1)/8+(nbplane-1)*sizex1/8-2
modulo_impair1=(sizex1-tracex1)/8+(nbplane-1)*sizex1/8-2

sizex2=320+16
sizey2=20
screen2size=sizex2*sizey2/8
displayx2=320
tracex2=320
stopx2=displayx2+startdisplayx-256
ddf_strt2=(startx-17)/2 
ddf_stop2=ddf_strt2+(tracex2/2-8)
modulo_pair2=(sizex2-tracex2)/8+(nbplane-1)*sizex2/8
modulo_impair2=(sizex2-tracex2)/8+(nbplane-1)*sizex2/8

starty0=starty
starty1=starty0+sizey0/2+1
starty2=starty1+sizey1+1

;+++++ si un ecran commence a starty et fait sizey, la derniere ligne
;+++++ est a la position starty+sizey-1, bien sur

;*************** CONSTANTES ***************

startplasmax=63
amplitude=48
delta=12
moves=displayx0/8+2*amplitude/8+1

scrollhauteur=5
scrollsize=15
scrollspeed=4
timer2=350
timer1=100
memory=$10000+2

copsize0=11*4+4*4+8*nbplane+sizey0/2*(4+4*moves)+3*4

;11*4 (parametres screen AGA compatible janvier 2003)
;4*4 (4 couleurs screen0)
;8*nbplane (adresses bitplanes)
;sizey0/2*(4+4*moves) (plasma)
;3*4 (copperline1:wait+$0180+$0100)

copsize1=6*4+3*4+8*nbplane+4+4+4+4+3*4

;6*4 (parametres screen)
;3*4 (3 couleurs)
;8*nbplane (adresses bitplanes)
;4+4+4 (wait+$0180+$0100)
;4 ($FFE1FFFE)
;3*4 (copperline2:wait+$0180+$0100)

copsize2=6*4+3*4+8*nbplane+4+4+4+2*scrollsize*(4+4*15)+4

;6*4 (parametres screen)
;3*4 (3 couleurs)
;8*nbplane (adresses bitplanes)
;4+4+4 (wait+$0180+$0100)
;2*scrollsize*(4+4*15) (degrade scroll)
;4 ($FFFFFFFE)

copsize=copsize0+copsize1+copsize2

;*************** PROGRAMME PRINCIPAL ***************

	bsr.w init

;----- initialisations music -----

	bsr module_adr
	bsr module_adr+4
	moveq #0,d0
	bsr module_adr+12

;----- logo sur screen0 -----
	
	move.l screen0adr,a0
	addi.l #nbplane*sizex0/8*sizey0/2,a0
	move.l a0,bltdpth
	move.l #logoadr,bltbpth
	move.w #(nbplane-1)*logosizex/8,bltbmod
	move.w #(sizex0-logosizex)/8+(nbplane-1)*sizex0/8,bltdmod
	move.w #logosizex/16+64*logosizey,bltsize
	bsr waitblit

;----- page de texte centre -----

	move.l screen1adr,a0
	lea 2(a0),a0
	lea (30-8)*nbplane*sizex1/8(a0),a0
	lea textCstart,a1
	move.w #textCsize-1,d0
	bsr textwriter

	move.l screen1adr,a0
	lea 2+(640-logosizex)/8/2(a0),a0
	lea 46*nbplane*sizex1/8(a0),a0
	move.l a0,bltdpth
	move.l #logoadr,bltbpth
	move.w #nbplane*sizex1/8-logosizex/8,bltdmod
	move.w #(nbplane-1)*logosizex/8,bltbmod
	move.w #logosizex/16+64*logosizey,bltsize
	bsr waitblit

;----- ombrage du texte centre -----

	move.l screen1adr,a0
	lea 2(a0),a0
	move.l a0,bltbpth
	lea 3*nbplane*sizex1/8+sizex1/8(a0),a0
	move.l a0,bltdpth
	move.w #$3000,bltcon1
	move.w #(nbplane-1)*sizex1/8+(sizex1-640)/8,bltbmod
	move.w #(nbplane-1)*sizex1/8+(sizex1-640)/8,bltdmod
	move.w #640/16+64*sizey1,bltsize
	bsr waitblit

;----- page de texte right -----

	move.l screen1adr,a0
	lea 2+640/8(a0),a0
	lea (30-8)*nbplane*sizex1/8(a0),a0
	lea textRstart,a1
	move.w #textRsize-1,d0
	bsr textwriter

;----- ombrage du texte right -----

	move.l screen1adr,a0
	lea 2+640/8(a0),a0
	move.l a0,bltbpth
	lea 3*nbplane*sizex1/8+sizex1/8(a0),a0
	move.l a0,bltdpth
	move.w #$3000,bltcon1
	move.w #(nbplane-1)*sizex1/8+(sizex1-640)/8,bltbmod
	move.w #(nbplane-1)*sizex1/8+(sizex1-640)/8,bltdmod
	move.w #640/16+64*sizey1,bltsize
	bsr waitblit

;----- page de texte left -----

	move.l screen1adr,a0
	lea -640/8+2(a0),a0
	lea (30-8)*nbplane*sizex1/8(a0),a0
	lea textLstart,a1
	move.w #textLsize-1,d0
	bsr textwriter

;----- ombrage du texte left -----

	move.l screen1adr,a0
	lea -640/8+2(a0),a0
	move.l a0,bltbpth
	lea 3*nbplane*sizex1/8+sizex1/8(a0),a0
	move.l a0,bltdpth
	move.w #$3000,bltcon1
	move.w #(nbplane-1)*sizex1/8+(sizex1-640)/8,bltbmod
	move.w #(nbplane-1)*sizex1/8+(sizex1-640)/8,bltdmod
	move.w #640/16+64*sizey1,bltsize
	bsr waitblit

;----- construit les datas du scroll -----

	move.l stringadr,a0
	lea stringstart,a1
	move.w #stringsize-1,d0
	move.w #0,d1
	move.w #0,d2
dataloop0:
	move.b (a1)+,d1
	move.w #-4,d3
	lea datachar,a2
dataloop1:
	addq.w #4,d3
	move.b (a2)+,d2
	cmp.b d1,d2
	bne dataloop1 
	lea datafont,a2
	lea (a2,d3.w),a2
	move.w (a2)+,(a0)+
	move.w (a2),(a0)+
	dbf d0,dataloop0

;----- montee du logo -----

	move.w #timer2-1,d0
waitloop0:
	bsr waitvbl
	dbf d0,waitloop0

	move.l screen0adr,d1
	move.l #sizey0/2-1,d0
logoloop0:
	move.l copadr,a1
	lea 11*4+4*4+2(a1),a1
	move.w #nbplane-1,d2
logoloop1:
	swap d1
	move.w d1,(a1)
	lea 4(a1),a1
	swap d1
	move.w d1,(a1)
	lea 4(a1),a1
	addi.l #sizex0/8,d1
	dbf d2,logoloop1
	bsr waitvbl
	bsr waitvbl
	dbf d0,logoloop0
	
;----- initialisations -----

	move.w #timer2,d2		;compteur (10 sec)
	move.l copadr,a5
	addi.l #copsize0+6*4+3*4+2,a5
	move.w #scrollspeed,d7
	ror #4,d7
	or.w #$2,d7			;mode ascending
	move.w #0,d6
	move.w #0,d5
	move.l stringadr,a6
	lea pagestart,a2		;scenario de defilement des pages
	move.w #0,d4			;hard scroll right
	move.w #0,d3			;hard scroll left

mainloop:

;----- effectue le scroll -----

	move.w d7,bltcon1
	move.w #(sizex2-displayx2)/8-2,bltdmod
	move.w #(sizex2-displayx2)/8-2,bltbmod
	move.l screen2adr,a0
	addi.l #nbplane*(scrollhauteur+scrollsize)*sizex2/8-(sizex2-displayx2)/8,a0
	move.l a0,bltbpth
	move.l a0,bltdpth
	move.w #(displayx2+16)/16+64*scrollsize*nbplane,bltsize
	bsr waitblit

;----- gere l'affichage du texte -----
	
	move.w #$0000,bltcon1
	addq.w #1,d6
	cmpi.w #16/scrollspeed,d6
	bne scrollsuite0
	move.w #0,d6
	cmpi.w #stringsize,d5		;fin de chaine ?
	bne scrollsuite1
	move.w #0,d5
	move.l stringadr,a6		;retour a la premiere lettre
scrollsuite1:
	move.w (a6)+,d0		;hauteur de la lettre dans le tableau font
	mulu #nbplane*fontsizex/8,d0
	add.w (a6)+,d0		;largeur de la lettre dans le tableau font
	move.l #fontadr,a0
	lea (a0,d0.w),a0
	move.l screen2adr,a1
	addi.l #nbplane*scrollhauteur*sizex2/8+displayx2/8,a1
	move.l a0,bltbpth
	move.l a1,bltdpth
	move.w #sizex2/8-2,bltdmod
	move.w #fontsizex/8-2,bltbmod
	move.w #1+64*scrollsize*nbplane,bltsize
	bsr waitblit
	addq.w #1,d5
scrollsuite0:
	
;----- effet plasma -----

	move.w #0,bltdmod
	move.w #0,bltbmod
	
	move.l copadr,a0
	lea 11*4+4*4+8*nbplane+4(a0),a0
	move.l a0,bltbpth
	move.l bufferadr,bltdpth
	move.w #2+moves*64,bltsize
	bsr waitblit
	
	move.w #(moves-32)*4+4,bltdmod
	move.w #(moves-32)*4+4,bltbmod

	move.l a0,bltdpth
	lea 4+moves*4(a0),a1
	move.l a1,bltbpth
	move.w #64+(sizey0/2-1)*64,bltsize
	bsr waitblit
	
	move.w #32*4+4,bltdmod
	move.w #32*4+4,bltbmod

	lea 32*4(a0),a0
	move.l a0,bltdpth
	lea 4+4*moves(a0),a0
	move.l a0,bltbpth
	move.w #(moves-32)*2+(sizey0/2-1)*64,bltsize
	bsr waitblit
	
	move.w #0,bltdmod
	move.w #0,bltbmod

	move.l copadr,a0
	addi.l #11*4+4*4+8*nbplane+(sizey0/2-1)*(4*moves+4)+4,a0
	move.l a0,bltdpth
	move.l bufferadr,bltbpth
	move.w #2+moves*64,bltsize
	bsr waitblit

;----- hardscroll du screen1 -----

	or.w d4,d4
	beq hardsuite0
	bsr hardright
	subq.w #1,d4
hardsuite0:

	or.w d3,d3
	beq hardsuite1
	bsr hardleft
	subq.w #1,d3
hardsuite1:

	or.w d4,d4
	bne hardsuite4
	or.w d3,d3
	bne hardsuite4
	subq.w #1,d2
	bne hardsuite4
	move.w #timer2,d2
	move.w (a2)+,d4
	move.w (a2)+,d3
	cmpi.l #pageend,a2
	bne hardsuite4
	lea pagestart,a2
hardsuite4:

	bsr waitvbl
	
	btst #6,$bfe001
	bne mainloop

;----- descente du logo -----

	move.l screen0adr,d1
	addi.l #nbplane*sizey0/2*sizex0/8,d1
	addi.l #(nbplane-1)*sizex0/8,d1
	move.l #sizey0/2-1,d0
logoloop2:
	move.l copadr,a1
	lea 11*4+4*4+6+8*(nbplane-1)(a1),a1
	move.w #nbplane-1,d2
logoloop3:
	move.w d1,(a1)
	lea -4(a1),a1
	swap d1
	move.w d1,(a1)
	swap d1
	lea -4(a1),a1
	subi.l #sizex0/8,d1
	dbf d2,logoloop3
	bsr waitvbl
	bsr waitvbl
	dbf d0,logoloop2

	bsr module_adr+16
	bsr module_adr+8
	bsr fin

	rts

;*************** HARD SCROLL LEFT ***************

hardleft:
	movem.l d0-d7/a0-a6,-(sp)
	
	move.l a5,a0
	move.w -32(a0),d0
	bne hardLsuite0
	move.w #$0044,-32(a0)
	move.w #nbplane-1,d1
hardLloop0:
	move.w (a0),d0		;D0=BPLxPTH
	swap d0
	move.w 4(a0),d0		;D0=BPLxPTH:BPLxPTL
	addi.l #2,d0
	move.w d0,4(a0)
	swap d0
	move.w d0,(a0)
	lea 8(a0),a0		;BPL(x+1)PTH
	dbf d1,hardLloop0
	jmp hardLsuite1
hardLsuite0:
	subi.w #$0044,-32(a0)
hardLsuite1:

	movem.l (sp)+,d0-d7/a0-a6

	rts

;*************** HARD SCROLL RIGHT ***************

hardright:
	movem.l d0-d7/a0-a6,-(sp)
	
	move.l a5,a0
	move.w -32(a0),d0
	cmpi.w #$0044,d0
	bne hardRsuite0
	move.w #$0000,-32(a0)
	move.w #nbplane-1,d1
hardRloop0:
	move.w (a0),d0		;D0=BPLxPTH
	swap d0
	move.w 4(a0),d0		;D0=BPLxPTH:BPLxPTL
	subi.l #2,d0
	move.w d0,4(a0)
	swap d0
	move.w d0,(a0)
	lea 8(a0),a0		;BPL(x+1)PTH
	dbf d1,hardRloop0
	jmp hardRsuite1
hardRsuite0:
	addi.w #$0044,-32(a0)
hardRsuite1:

	movem.l (sp)+,d0-d7/a0-a6

	rts

;*************** HARD SCROLL UP ***************

hardup:
	movem.l d0-d7/a0-a6,-(sp)
	
	move.l a5,a0
	move.w #nbplane-1,d1
hardUloop0:
	move.w (a0),d0		;D0=BPLxPTH
	swap d0
	move.w 4(a0),d0		;D0=BPLxPTH:BPLxPTL
	addi.l #nbplane*sizex1/8,d0
	move.w d0,4(a0)
	swap d0
	move.w d0,(a0)
	lea 8(a0),a0		;BPL(x+1)PTH
	dbf d1,hardUloop0

	movem.l (sp)+,d0-d7/a0-a6

	rts

;*************** HARD SCROLL DOWN ***************

harddown:
	movem.l d0-d7/a0-a6,-(sp)
	
	move.l a5,a0
	move.w #nbplane-1,d1
hardDloop0:
	move.w (a0),d0		;D0=BPLxPTH
	swap d0
	move.w 4(a0),d0		;D0=BPLxPTH:BPLxPTL
	subi.l #nbplane*sizex1/8,d0
	move.w d0,4(a0)
	swap d0
	move.w d0,(a0)
	lea 8(a0),a0		;BPL(x+1)PTH
	dbf d1,hardDloop0

	movem.l (sp)+,d0-d7/a0-a6

	rts

;*************** TEXT WRITER ***************

;A0=adresse screen
;A1=adresse texte
;D0=taille texte-1

textwriter:
	movem.l d0-d7/a0-a6,-(sp)
	
	move.l a0,a3
printloop0:
	move.w #0,d1
	move.b (a1)+,d1
	beq printsuite0			;passe a la ligne ?
	subi.b #$20,d1
	lsl.w #3,d1
	move.l a3,a2
	move.l #font8adr,a4
	lea (a4,d1.w),a4
	move.w #8-1,d1
printloop1:
	move.b (a4)+,(a2)
	lea nbplane*sizex1/8(a2),a2
	dbf d1,printloop1
	lea 1(a3),a3			;caractere suivant
	jmp printsuite1
printsuite0:
	lea 8*nbplane*sizex1/8(a0),a0	;passe a la ligne
	move.l a0,a3
	move.b (a1),d1			;autre passe a la ligne ?
	beq printsuite1
	move.w #1,d2			;si non, calcul centrage
	move.l a1,a4
printloop2:
	subq.w #1,d2
	move.b (a4)+,d1
	bne printloop2
	addi.w #640/8,d2
	lsr #1,d2
	lea (a3,d2.w),a3
printsuite1:
	dbf d0,printloop0

	movem.l (sp)+,d0-d7/a0-a6

	rts

;*************** INITIALISATION ***************

init:
	
;memoire pour copperlist

	move.l $4,a6		
	move.l #copsize,d0	
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,copadr	
	beq.w fin

;memoire pour screen0

	move.l #nbplane*screen0size,d0	
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,screen0adr	
	beq.w fin

;memoire pour screen1

	move.l #nbplane*screen1size,d0	
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,screen1adr	
	beq.w fin

	addi.l #640/8-2,screen1adr

;memoire pour screen2

	move.l #nbplane*screen2size,d0	
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,screen2adr	
	beq.w fin

;memoire pour texte

	move.l #stringsize*4,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,stringadr
	beq.w fin

;memoire pour positions horizontales

	move.l #2*sizey0/2,d0
	move.l #memory,d1	
	jsr allocmem(a6)
	move.l d0,posadr
	beq.w fin

;memoire pour index verticaux

	move.l #2*moves,d0
	move.l #memory,d1	
	jsr allocmem(a6)
	move.l d0,indexadr
	beq.w fin

;memoire pour buffer plasma

	move.l #4*moves,d0
	move.l #memory,d1	
	jsr allocmem(a6)
	move.l d0,bufferadr
	beq.w fin

;creation des index verticaux

	move.w #0,d0
	move.l indexadr,a1
	lea sinus,a0
	move.l #moves-1,d2
indexloop0:
	move.w d0,d1
	lsl #1,d1
	move.w (a0,d1.w),d1
	muls #20,d1
	swap d1
	rol.l #1,d1
	addi.w #20,d1
	bclr #0,d1		;les index doivent etre pairs
	and.w #$00FF,d1
	move.w d1,(a1)+
	addi.w #10,d0
	cmpi.w #360,d0
	bne indexsuite0
	move.w #0,d0
indexsuite0:
	dbf d2,indexloop0

;creation des positions horizontales

	move.w #0,d0		;d0=angle de depart
	move.l posadr,a1
	lea sinus,a0
	move.l #sizey0/2-1,d2
posloop0:
	move.w d0,d1
	lsl #1,d1
	move.w (a0,d1.w),d1
	muls #amplitude/2,d1
	swap d1
	rol.l #1,d1
	addi.w #startplasmax-amplitude/2,d1
	bset #0,d1		;les positions doivent etre impaires
	move.b d1,(a1)
	addq.l #2,a1
	add.w #delta,d0
	cmpi.w #360,d0
	bne possuite0
	move.w #0,d0
possuite0:
	dbf d2,posloop0

;creation de la copperlist

	move.l copadr,a0

;+++++ screen 0

	move.w #$008E,(a0)+		;DIWSTRT
	move.w #starty*256+startdisplayx,(a0)+
	move.w #$0090,(a0)+		;DIWSTOP
	move.w #stopy*256+stopx0,(a0)+
	move.w #$0100,(a0)+		;BPLCON0
	move.w #nbplane,d0
	ror.w #4,d0
	bset #9,d0
	move.w d0,(a0)+
	move.w #$0102,(a0)+		;BPLCON1
	move.w #$0000,(a0)+
	move.w #$0104,(a0)+		;BPLCON2
	move.w #$0000,(a0)+
	move.w #$0092,(a0)+		;DDFSTRT
	move.w #ddf_strt0,(a0)+
	move.w #$0094,(a0)+		;DDFSTOP
	move.w #ddf_stop0,(a0)+
	move.w #$0108,(a0)+		;BPL1MOD
	move.w #modulo_pair0,(a0)+
	move.w #$010A,(a0)+		;BPL2MOD
	move.w #modulo_impair0,(a0)+
	move.l #$01FC0000,(a0)+
	move.l #$01060000,(a0)+

	move.l #$01800000,(a0)+
	move.l #$01820FFF,(a0)+
	move.l #$01840000,(a0)+
	move.l #$01860000,(a0)+
	
	move.l #$E0,d1
	move.l screen0adr,d0
	move.l #nbplane-1,d2
coploop0:
	move.w d1,(a0)+			;registre BPLxPTH
	swap d0				;intervertit poids forts-faibles
	move.w d0,(a0)+			;bouge les poids forts planeadr
	addq.w #2,d1
	move.w d1,(a0)+			;registre BPLxPTL
	swap d0
	move.w d0,(a0)+			;bouge les poids faibles planeadr
	addq.w #2,d1
	addi.l #sizex0/8,d0		;prochain bitplane 
	dbf d2,coploop0

;+++++ plasma logo

	move.l posadr,a3
	move.w #starty0,d2	
	move.l #sizey0/2-1,d1	
copyloop1:
	move.b d2,(a0)+
	move.b (a3),(a0)+
	lea 2(a3),a3
	addq.b #1,d2
	move.w #$FFFE,(a0)+	
	move.w #moves-2,d3
	move.l indexadr,a1
copyloop0:
	move.w (a1),d0
	addq.w #2,(a1)
	cmpi.w #colorsize,(a1)
	bne copysuite0
	move.w #0,(a1)
copysuite0:
	lea 2(a1),a1
	lea colorstart,a2
	lea (a2,d0.w),a2
	move.w #$0182,(a0)+
	move.w (a2),(a0)+
	dbf d3,copyloop0
	move.w #$0182,(a0)+
	move.w #$0000,(a0)+	
	dbf d1,copyloop1

;+++++ copperline 1

	move.w #starty1-1,d0
	lsl.w #8,d0
	or.w #$01,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.l #$01000000,(a0)+
	move.l #$01800D6D,(a0)+
	
;+++++ screen 1

	move.w #$0090,(a0)+		;DIWSTOP
	move.w #stopy*256+stopx1,(a0)+
	move.w #$0102,(a0)+		;BPLCON1
	move.w #$0000,(a0)+
	move.w #$0092,(a0)+		;DDFSTRT
	move.w #ddf_strt1,(a0)+
	move.w #$0094,(a0)+		;DDFSTOP
	move.w #ddf_stop1,(a0)+
	move.w #$0108,(a0)+		;BPL1MOD
	move.w #modulo_pair1,(a0)+
	move.w #$010A,(a0)+		;BPL2MOD
	move.w #modulo_impair1,(a0)+

	move.l #$01820FDF,(a0)+
	move.l #$01840000,(a0)+
	move.l #$01860FDF,(a0)+
	
	move.w #nbplane-1,d0
	move.w #$E0,d2
	move.l screen1adr,d1
coploop3:
	move.w d2,(a0)+
	addq.w #2,d2
	swap d1
	move.w d1,(a0)+
	move.w d2,(a0)+
	addq.w #2,d2
	swap d1
	move.w d1,(a0)+
	addi.l #sizex1/8,d1
	dbf d0,coploop3

	move.w #starty1,d0
	lsl.w #8,d0
	or.w #$01,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	
	move.l #$01800727,(a0)+

	move.w #$0100,(a0)+
	move.w #nbplane,d0
	ror.w #4,d0
	bset #9,d0
	bset #15,d0
	move.w d0,(a0)+

	move.l #$FFE1FFFE,(a0)+

;+++++ copperline 2

	move.w #starty2-1,d0
	lsl.w #8,d0
	or.w #$01,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.l #$01000000,(a0)+
	move.l #$01800D6D,(a0)+

;+++++ screen 2

	move.w #$0090,(a0)+		;DIWSTOP
	move.w #stopy*256+stopx2,(a0)+
	move.w #$0102,(a0)+		;BPLCON1
	move.w #$0000,(a0)+
	move.w #$0092,(a0)+		;DDFSTRT
	move.w #ddf_strt2,(a0)+
	move.w #$0094,(a0)+		;DDFSTOP
	move.w #ddf_stop2,(a0)+
	move.w #$0108,(a0)+		;BPL1MOD
	move.w #modulo_pair2,(a0)+
	move.w #$010A,(a0)+		;BPL2MOD
	move.w #modulo_impair2,(a0)+

	move.l #$01820000,(a0)+
	move.l #$01840000,(a0)+
	move.l #$01860000,(a0)+
	
	move.l #$E0,d1
	move.l screen2adr,d0
	move.l #nbplane-1,d2
coploop5:
	move.w d1,(a0)+			;registre BPLxPTH
	swap d0				;intervertit poids forts-faibles
	move.w d0,(a0)+			;bouge les poids forts planeadr
	addq.w #2,d1
	move.w d1,(a0)+			;registre BPLxPTL
	swap d0
	move.w d0,(a0)+			;bouge les poids faibles planeadr
	addq.w #2,d1
	addi.l #sizex2/8,d0		;prochain bitplane 
	dbf d2,coploop5

	move.w #starty2,d0
	lsl.w #8,d0
	or.w #$01,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+

	move.l #$01800000,(a0)+
	
	move.w #$0100,(a0)+		;BPLCON0
	move.w #nbplane,d0
	ror.w #4,d0
	bset #9,d0
	move.w d0,(a0)+

	move.w #starty2+scrollhauteur,d0
	lsl.w #8,d0
	move.w d0,d1
	or.w #startplasmax+displayx2/2-15*8/2,d1
	or.w d0,d1
	or.w #startplasmax+4,d0
	move.w #1,d4
	move.w #-2,d5
	move.w #2,d6
	move.w #scrollsize-1,d7
coploop9:
	move.w d0,(a0)+
	addi.w #$0100,d0
	add.w d5,d0
	cmpi.w #scrollsize/2,d4
	bne copsuite2
	neg d5
copsuite2:
	move.w #$FFFE,(a0)+
	move.w #1,red
	move.w #0,green
	move.w #1,blue
	move.w #15-1,d2
coploop10:
	move.w #$0182,(a0)+
	move.w red,d3
	lsl #4,d3
	or.w green,d3
	lsl #4,d3
	or.w blue,d3
	move.w d3,(a0)+
	addq.w #1,red
	cmpi.w #$F,red
	ble redsuite1
	move.w #$F,red
redsuite1:
	addq.w #1,green
	cmpi.w #$D,green
	ble greensuite1
	move.w #$D,green
greensuite1:
	addq.w #1,blue
	cmpi.w #$F,blue
	ble bluesuite1
	move.w #$F,blue
bluesuite1:
	dbf d2,coploop10

	move.w d1,(a0)+
	addi.w #$0100,d1
	add.w d6,d1
	cmpi.w #scrollsize/2,d4
	bne copsuite3
	neg d6
copsuite3:
	move.w #$FFFE,(a0)+
	move.w #$F,red
	move.w #$D,green
	move.w #$F,blue
	move.w #15-1,d2
coploop11:
	move.w #$0182,(a0)+
	move.w red,d3
	lsl #4,d3
	or.w green,d3
	lsl #4,d3
	or.w blue,d3
	move.w d3,(a0)+
	subq.w #1,red
	bge redsuite0
	move.w #0,red
redsuite0:
	subq.w #1,green
	bge greensuite0
	move.w #0,green
greensuite0:
	subq.w #1,blue
	bge bluesuite0
	move.w #0,blue
bluesuite0:
	dbf d2,coploop11
	
	addq.w #1,d4	
	dbf d7,coploop9

	move.l #$FFFFFFFE,(a0)
	
;modif DMA,...
	
	jsr forbid(a6)
	move.w #$03F0,dmacon		;couper tous les DMA
	move.l copadr,cop1lch		;adresse coplist1
	clr.w copjmp1			;copjump1
	move.w #$87C0,dmacon		;COPEN et BPLEN et BLTPRI
	move.w #%0000010111001100,bltcon0	;%0000100111110000
						;0000:decalage d'entree A=0
						;0101:canaux DMA blitter 
						;     source B et cible D actifs
						;1100:minterms ABC,ABc
						;     actifs
						;1100:minterms aBC,aBc
						;     inactifs
	move.w #%0000000000000000,bltcon1	;%0000000000000000
						;0000:decalage d'entree B=0
						;0000000:non utilises
						;0:EFE inactif
						;0:IFE inactif
						;0:FCI inactif
						;0:ascending mode
						;0:line inactif	
	rts
	
;*************** FIN PROGRAMME ***************

fin:

;restaurer la copperlist du dos

	move.l $4,a6
	move.l #grname,a1		
	clr.l d0
	jsr openlibrary(a6)		
	move.l d0,a4			
	move.l 38(a4),cop1lch	
	clr.w copjmp1
	move.w #$83F0,dmacon	
	jsr permit(a6)			

;liberation memoire positions horizontales

	move.l posadr,a1
	move.l #2*sizey0/2,d0
	jsr freemem(a6)

;liberation memoire index verticaux

	move.l indexadr,a1
	move.l #2*moves,d0
	jsr freemem(a6)

;liberation memoire copper

	move.l copadr,a1
	move.l #copsize,d0
	jsr freemem(a6)

;liberation memoire screen0

	move.l screen0adr,a1
	move.l #nbplane*screen0size,d0
	jsr freemem(a6)

;liberation memoire screen1

	subi.l #640/8-2,screen1adr

	move.l screen1adr,a1
	move.l #nbplane*screen1size,d0
	jsr freemem(a6)

;liberation memoire screen2

	move.l screen2adr,a1
	move.l #nbplane*screen2size,d0
	jsr freemem(a6)

;liberation memoire texte

	move.l stringadr,a1
	move.l #stringsize*4,d0
	jsr freemem(a6)

;liberation memoire buffer plasma

	move.l bufferadr,a1
	move.l #moves*4,d0
	jsr freemem(a6)

	rts

;*************** WAITBLIT ***************

waitblit:
	btst #14,dmaconr
	bne waitblit
	rts
	
;*************** LEFTCLICK ***************

leftclick:
	btst #6,$BFE001
	bne leftclick
	rts

;*************** ATTENTE ***************

attente:

attente1:
	cmp.b #$39,$bfec01
	bne attente1
attente2:
	cmp.b #$37,$bfec01
	bne attente2
	rts

;*************** WAITVBL ***************

waitvbl:
	cmp.b #$FF,vhposr
	bne waitvbl	
	rts

;*************** VARIABLES ***************

red:		dc.w 0
green:		dc.w 0
blue:		dc.w 0
font8adr:	incbin "sources:comotion/metallion.fnt"
fontadr:	incbin "sources:comotion/copper16.rawb"
logoadr:	incbin "sources:comotion/logo1.rawb"
bufferadr:	dc.l 0
posadr:		dc.l 0
indexadr:	dc.l 0
stringadr:	dc.l 0
screen0adr:	dc.l 0
screen1adr:	dc.l 0
screen2adr:	dc.l 0
copadr:		dc.l 0
oldirq:		dc.l 0
grname:		dc.b 'graphics.library',0
	even

pagestart:
	dc.w 640/8,0		;1 page a gauche
	dc.w 0,640/8		;1 page a droite
	dc.w 0,640/8		;1 page a droite
	dc.w 640/8,0		;1 page a gauche
pageend:

textCstart:
	dc.b 0,'Welcome to the first intro of...'
	dc.b 0,0,0,0,0,0,0,0,'The credits:'
	dc.b 0,0,'All Coding ... YRAGAEL'
	dc.b 0,0,'Design ... STORMTROOPER & YRAGAEL',0
textCend:
	even
textCsize=textCend-textCstart

textLstart:
	dc.b 0,0,'COMOTION is a new FRENCH demo group. There are just 2'
	dc.b 0,'members in COMOTION today: YRAGAEL and STORMTROOPER.'
	dc.b 0,'We are looking for new members, so if you are a good'
	dc.b 0,'graphic artist or a swapper contact us now.' 
	dc.b 0,0,'Our golden regards go to:' 
	dc.b 0,0,'Dark Entries, Melon Design, Crystal, LSD, TSB,'
	dc.b 0,'Majic 12 Fr (good luck !), Syntex (great animator!),'
	dc.b 0,'Flint/NIRVANA, RHAH (lazy boy!), Mr Big/ANARCHY,'
	dc.b 0,'Zinko/MAJIC 12, Bombsquad/KROM, Lucas/ACUME, 7th Eye.'
	dc.b 0,0,'and to some other guys:'
	dc.b 0,'Rookie, The Heathen, Zedzero and Poipoi...',0
textLend:
	even
textLsize=textLend-textLstart

textRstart:
	dc.b 0,'--- HOW IT ALL BEGAN ---'
	dc.b 0,0,'A couple of months ago Yragael and Stormtrooper'
	dc.b 0,'decided to create a demo group and what you see is' 
	dc.b 0,'only a fraction of the talent our coder has achieved'
	dc.b 0,'after having started to code only 4 months ago.'
	dc.b 0,0,0,'More is to come soon so do not miss it ! '
	dc.b 0,0,'For a contact address see below...',0
textRend:
	even
textRsize=textRend-textRstart

stringstart:	
	dc.b 'the first intro... the first steps towards fame and glory'
	dc.b ' for...    c o m o t i o n !!!  stm at the keyboard here'
	dc.b ' and as you can see a new name in the scene has appeared'
	dc.b ' and its aim is to stun you with more and more quality'
	dc.b ' productions ! hmmmm... demos are more and more boring as'
	dc.b ' coders keep copying each other in the now famous "i-can-'
	dc.b 'put-more-bobs-on-the-screen-than-you" syndrome. well'
	dc.b ' stuff that !!! cut the crap ! in our future prods we will'
	dc.b ' make sure that comotion will be a name to remember...    '
	dc.b ' if you want to contact us: 3614 rtel2 bal'
        dc.b ' comotion. this work of digital art was made possible thanks'
        dc.b ' to yragael (coding), stormtrooper (design)...  music by savage,'
        dc.b ' font8 by metallion and font16 by ???'
	dc.b '                                                         '  
        dc.b ' *** fabrice  et laurent k. sont des petites bites ***    '
	dc.b '                                                         '  
stringend:
	even
stringsize=stringend-stringstart

datachar:
	dc.b $61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D
	dc.b $6E,$6F,$70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A
	dc.b $30,$31,$32,$33,$34,$35,$36,$37,$38,$39
	dc.b $3F,$3D,$3A,$3B,$21,$22,$27,$28,$29,$2B,$2C,$2D,$2E,$2A
	dc.b $2F,$5C,$20
	even

datafont:
;A
	dc.w 0,0
;B
	dc.w 0,2
;C
	dc.w 0,4
;D
	dc.w 0,6
;E
	dc.w 0,8
;F
	dc.w 0,10
;G
	dc.w 0,12
;H
	dc.w 0,14
;I
	dc.w 0,16
;J
	dc.w 0,18
;K
	dc.w 0,20
;L
	dc.w 0,22
;M
	dc.w 0,24
;N
	dc.w 0,26
;O
	dc.w 0,28
;P
	dc.w 0,30
;Q
	dc.w 0,32
;R
	dc.w 0,34
;S
	dc.w 0,36
;T
	dc.w 0,38
;U
	dc.w 16,0
;V
	dc.w 16,2
;W
	dc.w 16,4
;X
	dc.w 16,6
;Y
	dc.w 16,8
;Z
	dc.w 16,10
;0
	dc.w 16,12
;1
	dc.w 16,14
;2
	dc.w 16,16
;3
	dc.w 16,18
;4
	dc.w 16,20
;5
	dc.w 16,22
;6
	dc.w 16,24
;7
	dc.w 16,26
;8
	dc.w 16,28
;9
	dc.w 16,30
;?
	dc.w 16,32
;=
	dc.w 16,34
;:
	dc.w 16,36
;;
	dc.w 16,38
;!
	dc.w 32,0
;"	
	dc.w 32,2
;'
	dc.w 32,4	
;(
	dc.w 32,6
;)
	dc.w 32,8
;+
	dc.w 32,10
;,
	dc.w 32,12
;-
	dc.w 32,14
;.
	dc.w 32,16
;*
	dc.w 32,18
;/
	dc.w 32,20
;\
	dc.w 32,22
;
	dc.w 32,24

sinus:
	dc.w 0,572,1144,1715,2286,2856
	dc.w 3425,3993,4560,5126,5690
	dc.w 6252,6813,7371,7927,8481
	dc.w 9032,9580,10126,10668,11207
	dc.w 11743,12275,12803,13328,13848
	dc.w 14365,14876,15384,15886,16384
	dc.w 16877,17364,17847,18324,18795
	dc.w 19261,19720,20174,20622,21063
	dc.w 21498,21926,22348,22763,23170
	dc.w 23571,23965,24351,24730,25102
	dc.w 25466,25822,26170,26510,26842
	dc.w 27166,27482,27789,28088,28378
	dc.w 28660,28932,29196,29452,29698
	dc.w 29935,30163,30382,30592,30792
	dc.w 30983,31164,31336,31499,31651
	dc.w 31795,31928,32052,32166,32270
	dc.w 32365,32449,32524,32588,32643
	dc.w 32688,32723,32748,32763,32767

	dc.w 32763,32748,32723,32688
	dc.w 32643,32588,32524,32449,32365
	dc.w 32270,32166,32052,31928,31795
	dc.w 31651,31499,31336,31164,30983
	dc.w 30792,30592,30382,30163,29935
	dc.w 29698,29452,29196,28932,28660
	dc.w 28378,28088,27789,27482,27166
	dc.w 26842,26510,26170,25822,25466
	dc.w 25102,24730,24351,23965,23571
	dc.w 23170,22763,22348,21926,21498
	dc.w 21063,20622,20174,19720,19261
	dc.w 18795,18324,17847,17364,16877
	dc.w 16384,15886,15384,14876,14365
	dc.w 13848,13328,12803,12275,11743
	dc.w 11207,10668,10126,9580,9032
	dc.w 8481,7927,7371,6813,6252
	dc.w 5690,5126,4560,3993,3425
	dc.w 2856,2286,1715,1144,572,0

	dc.w -572,-1144,-1715,-2286,-2856
	dc.w -3425,-3993,-4560,-5126,-5690
	dc.w -6252,-6813,-7371,-7927,-8481
	dc.w -9032,-9580,-10126,-10668,-11207
	dc.w -11743,-12275,-12803,-13328,-13848
	dc.w -14365,-14876,-15384,-15886,-16384
	dc.w -16877,-17364,-17847,-18324,-18795
	dc.w -19261,-19720,-20174,-20622,-21063
	dc.w -21498,-21926,-22348,-22763,-23170
	dc.w -23571,-23965,-24351,-24730,-25102
	dc.w -25466,-25822,-26170,-26510,-26842
	dc.w -27166,-27482,-27789,-28088,-28378
	dc.w -28660,-28932,-29196,-29452,-29698
	dc.w -29935,-30163,-30382,-30592,-30792
	dc.w -30983,-31164,-31336,-31499,-31651
	dc.w -31795,-31928,-32052,-32166,-32270
	dc.w -32365,-32449,-32524,-32588,-32643
	dc.w -32688,-32723,-32748,-32763,-32767

	dc.w -32763,-32748,-32723,-32688
	dc.w -32643,-32588,-32524,-32449,-32365
	dc.w -32270,-32166,-32052,-31928,-31795
	dc.w -31651,-31499,-31336,-31164,-30983
	dc.w -30792,-30592,-30382,-30163,-29935
	dc.w -29698,-29452,-29196,-28932,-28660
	dc.w -28378,-28088,-27789,-27482,-27166
	dc.w -26842,-26510,-26170,-25822,-25466
	dc.w -25102,-24730,-24351,-23965,-23571
	dc.w -23170,-22763,-22348,-21926,-21498
	dc.w -21063,-20622,-20174,-19720,-19261
	dc.w -18795,-18324,-17847,-17364,-16877
	dc.w -16384,-15886,-15384,-14876,-14365
	dc.w -13848,-13328,-12803,-12275,-11743
	dc.w -11207,-10668,-10126,-9580,-9032
	dc.w -8481,-7927,-7371,-6813,-6252
	dc.w -5690,-5126,-4560,-3993,-3425
	dc.w -2856,-2286,-1715,-1144,-572

cosinus:	
	dc.w 32767,32763,32748,32723,32688
	dc.w 32643,32588,32524,32449,32365
	dc.w 32270,32166,32052,31928,31795
	dc.w 31651,31499,31336,31164,30983
	dc.w 30792,30592,30382,30163,29935
	dc.w 29698,29452,29196,28932,28660
	dc.w 28378,28088,27789,27482,27166
	dc.w 26842,26510,26170,25822,25466
	dc.w 25102,24730,24351,23965,23571
	dc.w 23170,22763,22348,21926,21498
	dc.w 21063,20622,20174,19720,19261
	dc.w 18795,18324,17847,17364,16877
	dc.w 16384,15886,15384,14876,14365
	dc.w 13848,13328,12803,12275,11743
	dc.w 11207,10668,10126,9580,9032
	dc.w 8481,7927,7371,6813,6252
	dc.w 5690,5126,4560,3993,3425
	dc.w 2856,2286,1715,1144,572,0

	dc.w -572,-1144,-1715,-2286,-2856
	dc.w -3425,-3993,-4560,-5126,-5690
	dc.w -6252,-6813,-7371,-7927,-8481
	dc.w -9032,-9580,-10126,-10668,-11207
	dc.w -11743,-12275,-12803,-13328,-13848
	dc.w -14365,-14876,-15384,-15886,-16384
	dc.w -16877,-17364,-17847,-18324,-18795
	dc.w -19261,-19720,-20174,-20622,-21063
	dc.w -21498,-21926,-22348,-22763,-23170
	dc.w -23571,-23965,-24351,-24730,-25102
	dc.w -25466,-25822,-26170,-26510,-26842
	dc.w -27166,-27482,-27789,-28088,-28378
	dc.w -28660,-28932,-29196,-29452,-29698
	dc.w -29935,-30163,-30382,-30592,-30792
	dc.w -30983,-31164,-31336,-31499,-31651
	dc.w -31795,-31928,-32052,-32166,-32270
	dc.w -32365,-32449,-32524,-32588,-32643
	dc.w -32688,-32723,-32748,-32763,-32767

	dc.w -32763,-32748,-32723,-32688
	dc.w -32643,-32588,-32524,-32449,-32365
	dc.w -32270,-32166,-32052,-31928,-31795
	dc.w -31651,-31499,-31336,-31164,-30983
	dc.w -30792,-30592,-30382,-30163,-29935
	dc.w -29698,-29452,-29196,-28932,-28660
	dc.w -28378,-28088,-27789,-27482,-27166
	dc.w -26842,-26510,-26170,-25822,-25466
	dc.w -25102,-24730,-24351,-23965,-23571
	dc.w -23170,-22763,-22348,-21926,-21498
	dc.w -21063,-20622,-20174,-19720,-19261
	dc.w -18795,-18324,-17847,-17364,-16877
	dc.w -16384,-15886,-15384,-14876,-14365
	dc.w -13848,-13328,-12803,-12275,-11743
	dc.w -11207,-10668,-10126,-9580,-9032
	dc.w -8481,-7927,-7371,-6813,-6252
	dc.w -5690,-5126,-4560,-3993,-3425
	dc.w -2856,-2286,-1715,-1144,-572

	dc.w 0,572,1144,1715,2286,2856
	dc.w 3425,3993,4560,5126,5690
	dc.w 6252,6813,7371,7927,8481
	dc.w 9032,9580,10126,10668,11207
	dc.w 11743,12275,12803,13328,13848
	dc.w 14365,14876,15384,15886,16384
	dc.w 16877,17364,17847,18324,18795
	dc.w 19261,19720,20174,20622,21063
	dc.w 21498,21926,22348,22763,23170
	dc.w 23571,23965,24351,24730,25102
	dc.w 25466,25822,26170,26510,26842
	dc.w 27166,27482,27789,28088,28378
	dc.w 28660,28932,29196,29452,29698
	dc.w 29935,30163,30382,30592,30792
	dc.w 30983,31164,31336,31499,31651
	dc.w 31795,31928,32052,32166,32270
	dc.w 32365,32449,32524,32588,32643
	dc.w 32688,32723,32748,32763

colorstart:
	dc.w $0404	
	dc.w $0404
	dc.w $0515
	
	dc.w $0515
	dc.w $0616
	dc.w $0616
	dc.w $0727
	dc.w $0727
	
	dc.w $0828
	dc.w $0828
	dc.w $0939
	dc.w $0939
	dc.w $0A49
	
	dc.w $0A49
	dc.w $0B49
	dc.w $0B49
	dc.w $0C59
	dc.w $0C59
	
	dc.w $0D6A
	dc.w $0D6A
	dc.w $0E6A
	dc.w $0E6A
	dc.w $0F7B
	
	dc.w $0F7B
	dc.w $0F8C
	dc.w $0F8C
	dc.w $0F9D
	dc.w $0F9D

	dc.w $0FAD
	dc.w $0FAD
	dc.w $0EAD
	dc.w $0EAD
	dc.w $0D9C
	
	dc.w $0D9B
	dc.w $0C8B
	dc.w $0B7A
	dc.w $0B6A
	dc.w $0A69
	
	dc.w $0958
	dc.w $0947
	dc.w $0837
	dc.w $0736
	dc.w $0726

	dc.w $0615
	dc.w $0605
	dc.w $0505
colorend:
colorsize=colorend-colorstart

module_adr:	incbin "sources:comotion/mod.hold_of_fame.pc"

